/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2024  SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.messages;

import com.velocitypowered.api.proxy.Player;
import com.velocitypowered.api.proxy.player.PlayerSettings;
import de.steamwar.sql.SteamwarUser;
import lombok.AllArgsConstructor;
import net.kyori.adventure.text.Component;

import java.util.Locale;
import java.util.function.Consumer;

@AllArgsConstructor
public class PlayerChatter implements Chatter {

    private final Player player;
    private final Consumer<Component> sendMessage;

    @Override
    public SteamwarUser user() {
        return SteamwarUser.get(player.getUniqueId());
    }

    @Override
    public Locale getLocale() {
        return user().getLocale();
    }

    @Override
    public boolean chatShown() {
        if(!player.hasSentPlayerSettings())
            return false;

        return player.getPlayerSettings().getChatMode() == PlayerSettings.ChatMode.SHOWN;
    }

    @Override
    public void sendMessage(Component msg) {
        sendMessage.accept(msg);
    }

    @Override
    public Player getPlayer() {
        return player;
    }
}
